Tolerate base64 encoded Gerrit comments
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2020 Cisco and/or its affiliates.
2 # Copyright (c) 2020 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
46     case_text="${NODENESS}_${FLAVOR}"
47     case "${case_text}" in
48         "1n_skx" | "1n_tx2")
49             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
50             # script's functions. Env variables are read from ssh output
51             # back to localhost for further processing.
52             # Shim and Jenkins executor are in the same network on the same host
53             # Connect to docker's default gateway IP and shim's exposed port
54             ssh="ssh root@172.17.0.1 -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # The "declare -f" output is long and boring.
57             set +x
58             # backtics to avoid https://midnight-commander.org/ticket/2142
59             env_vars=`${ssh} "$(declare -f); ${run}"` || {
60                 die "Topology reservation via shim-dcr failed!"
61             }
62             set -x
63             set -a
64             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
65                 die "Source failed!"
66             }
67             set +a
68             ;;
69         "1n_vbox")
70             # We execute reservation on localhost. Sourced script automatially
71             # sets environment variables for further processing.
72             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
73             ;;
74         *)
75             die "Unknown specification: ${case_text}!"
76     esac
77
78     trap 'deactivate_docker_topology' EXIT || {
79          die "Trap attempt failed, please cleanup manually. Aborting!"
80     }
81
82     # Replace all variables in template with those in environment.
83     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
84         die "Topology file create failed!"
85     }
86
87     WORKING_TOPOLOGY="/tmp/topology.yaml"
88     mv topo.yml "${WORKING_TOPOLOGY}" || {
89         die "Topology move failed!"
90     }
91     cat ${WORKING_TOPOLOGY} | grep -v password || {
92         die "Topology read failed!"
93     }
94 }
95
96
97 function activate_virtualenv () {
98
99     # Update virtualenv pip package, delete and create virtualenv directory,
100     # activate the virtualenv, install requirements, set PYTHONPATH.
101
102     # Arguments:
103     # - ${1} - Path to existing directory for creating virtualenv in.
104     #          If missing or empty, ${CSIT_DIR} is used.
105     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
106     # Variables read:
107     # - CSIT_DIR - Path to existing root of local CSIT git repository.
108     # Variables exported:
109     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
110     # Functions called:
111     # - die - Print to stderr and exit.
112
113     set -exuo pipefail
114
115     root_path="${1-$CSIT_DIR}"
116     env_dir="${root_path}/env"
117     req_path=${2-$CSIT_DIR/requirements.txt}
118     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
119     pip3 install virtualenv==20.0.20 || {
120         die "Virtualenv package install failed."
121     }
122     virtualenv --no-download --python=$(which python3) "${env_dir}" || {
123         die "Virtualenv creation for $(which python3) failed."
124     }
125     set +u
126     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
127     set -u
128     pip3 install -r "${req_path}" || {
129         die "Requirements installation failed."
130     }
131     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
132     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
133 }
134
135
136 function archive_tests () {
137
138     # Create .tar.xz of generated/tests for archiving.
139     # To be run after generate_tests, kept separate to offer more flexibility.
140
141     # Directory read:
142     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
143     # File rewriten:
144     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
145
146     set -exuo pipefail
147
148     tar c "${GENERATED_DIR}/tests" | xz -3 > "${ARCHIVE_DIR}/tests.tar.xz" || {
149         die "Error creating archive of generated tests."
150     }
151 }
152
153
154 function check_download_dir () {
155
156     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
157     #
158     # Variables read:
159     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
160     # Directories read:
161     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
162     # Functions called:
163     # - die - Print to stderr and exit.
164
165     set -exuo pipefail
166
167     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
168         die "No artifacts downloaded!"
169     fi
170 }
171
172
173 function check_prerequisites () {
174
175     # Fail if prerequisites are not met.
176     #
177     # Functions called:
178     # - installed - Check if application is installed/present in system.
179     # - die - Print to stderr and exit.
180
181     set -exuo pipefail
182
183     if ! installed sshpass; then
184         die "Please install sshpass before continue!"
185     fi
186 }
187
188
189 function common_dirs () {
190
191     # Set global variables, create some directories (without touching content).
192
193     # Variables set:
194     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
195     # - CSIT_DIR - Path to existing root of local CSIT git repository.
196     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
197     # - JOB_SPECS_DIR - Path to existing directory with job test specifications.
198     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
199     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
200     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
201     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
202     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
203     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
204     # Directories created if not present:
205     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
206     # Functions called:
207     # - die - Print to stderr and exit.
208
209     set -exuo pipefail
210
211     this_file=$(readlink -e "${BASH_SOURCE[0]}") || {
212         die "Some error during locating of this source file."
213     }
214     BASH_FUNCTION_DIR=$(dirname "${this_file}") || {
215         die "Some error during dirname call."
216     }
217     # Current working directory could be in a different repo, e.g. VPP.
218     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
219     relative_csit_dir=$(git rev-parse --show-toplevel) || {
220         die "Git rev-parse failed."
221     }
222     CSIT_DIR=$(readlink -e "${relative_csit_dir}") || die "Readlink failed."
223     popd || die "Popd failed."
224     TOPOLOGIES_DIR=$(readlink -e "${CSIT_DIR}/topologies/available") || {
225         die "Readlink failed."
226     }
227     JOB_SPECS_DIR=$(readlink -e "${CSIT_DIR}/docs/job_specs") || {
228         die "Readlink failed."
229     }
230     RESOURCES_DIR=$(readlink -e "${CSIT_DIR}/resources") || {
231         die "Readlink failed."
232     }
233     TOOLS_DIR=$(readlink -e "${RESOURCES_DIR}/tools") || {
234         die "Readlink failed."
235     }
236     DOC_GEN_DIR=$(readlink -e "${TOOLS_DIR}/doc_gen") || {
237         die "Readlink failed."
238     }
239     PYTHON_SCRIPTS_DIR=$(readlink -e "${TOOLS_DIR}/scripts") || {
240         die "Readlink failed."
241     }
242
243     ARCHIVE_DIR=$(readlink -f "${CSIT_DIR}/archive") || {
244         die "Readlink failed."
245     }
246     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
247     DOWNLOAD_DIR=$(readlink -f "${CSIT_DIR}/download_dir") || {
248         die "Readlink failed."
249     }
250     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
251     GENERATED_DIR=$(readlink -f "${CSIT_DIR}/generated") || {
252         die "Readlink failed."
253     }
254     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
255 }
256
257
258 function compose_pybot_arguments () {
259
260     # Variables read:
261     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
262     # - DUT - CSIT test/ subdirectory, set while processing tags.
263     # - TAGS - Array variable holding selected tag boolean expressions.
264     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
265     # - TEST_CODE - The test selection string from environment or argument.
266     # Variables set:
267     # - PYBOT_ARGS - String holding part of all arguments for pybot.
268     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
269
270     set -exuo pipefail
271
272     # No explicit check needed with "set -u".
273     PYBOT_ARGS=("--loglevel" "TRACE")
274     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
275
276     case "${TEST_CODE}" in
277         *"device"*)
278             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
279             ;;
280         *"perf"*)
281             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
282             ;;
283         *)
284             die "Unknown specification: ${TEST_CODE}"
285     esac
286
287     EXPANDED_TAGS=()
288     for tag in "${TAGS[@]}"; do
289         if [[ ${tag} == "!"* ]]; then
290             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
291         else
292             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
293         fi
294     done
295 }
296
297
298 function copy_archives () {
299
300     # Create additional archive if workspace variable is set.
301     # This way if script is running in jenkins all will be
302     # automatically archived to logs.fd.io.
303     #
304     # Variables read:
305     # - WORKSPACE - Jenkins workspace, copy only if the value is not empty.
306     #   Can be unset, then it speeds up manual testing.
307     # - ARCHIVE_DIR - Path to directory with content to be copied.
308     # Directories updated:
309     # - ${WORKSPACE}/archives/ - Created if does not exist.
310     #   Content of ${ARCHIVE_DIR}/ is copied here.
311     # Functions called:
312     # - die - Print to stderr and exit.
313
314     set -exuo pipefail
315
316     if [[ -n "${WORKSPACE-}" ]]; then
317         mkdir -p "${WORKSPACE}/archives/" || die "Archives dir create failed."
318         cp -rf "${ARCHIVE_DIR}"/* "${WORKSPACE}/archives" || die "Copy failed."
319     fi
320 }
321
322
323 function deactivate_docker_topology () {
324
325     # Deactivate virtual vpp-device topology by removing containers.
326     #
327     # Variables read:
328     # - NODENESS - Node multiplicity of desired testbed.
329     # - FLAVOR - Node flavor string, usually describing the processor.
330
331     set -exuo pipefail
332
333     case_text="${NODENESS}_${FLAVOR}"
334     case "${case_text}" in
335         "1n_skx" | "1n_tx2")
336             ssh="ssh root@172.17.0.1 -p 6022"
337             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
338             # The "declare -f" output is long and boring.
339             set +x
340             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
341                 die "Topology cleanup via shim-dcr failed!"
342             }
343             set -x
344             ;;
345         "1n_vbox")
346             enter_mutex || die
347             clean_environment || {
348                 die "Topology cleanup locally failed!"
349             }
350             exit_mutex || die
351             ;;
352         *)
353             die "Unknown specification: ${case_text}!"
354     esac
355 }
356
357
358 function die () {
359
360     # Print the message to standard error end exit with error code specified
361     # by the second argument.
362     #
363     # Hardcoded values:
364     # - The default error message.
365     # Arguments:
366     # - ${1} - The whole error message, be sure to quote. Optional
367     # - ${2} - the code to exit with, default: 1.
368
369     set -x
370     set +eu
371     warn "${1:-Unspecified run-time error occurred!}"
372     exit "${2:-1}"
373 }
374
375
376 function die_on_pybot_error () {
377
378     # Source this fragment if you want to abort on any failed test case.
379     #
380     # Variables read:
381     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
382     # Functions called:
383     # - die - Print to stderr and exit.
384
385     set -exuo pipefail
386
387     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
388         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
389     fi
390 }
391
392
393 function generate_tests () {
394
395     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
396     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
397     # The generation is done by executing any *.py executable
398     # within any subdirectory after copying.
399
400     # This is a separate function, because this code is called
401     # both by autogen checker and entries calling run_pybot.
402
403     # Directories read:
404     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
405     # Directories replaced:
406     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
407
408     set -exuo pipefail
409
410     rm -rf "${GENERATED_DIR}/tests" || die
411     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
412     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
413     cmd_line+=("-executable" "-name" "*.py")
414     # We sort the directories, so log output can be compared between runs.
415     file_list=$("${cmd_line[@]}" | sort) || die
416
417     for gen in ${file_list}; do
418         directory="$(dirname "${gen}")" || die
419         filename="$(basename "${gen}")" || die
420         pushd "${directory}" || die
421         ./"${filename}" || die
422         popd || die
423     done
424 }
425
426
427 function get_test_code () {
428
429     # Arguments:
430     # - ${1} - Optional, argument of entry script (or empty as unset).
431     #   Test code value to override job name from environment.
432     # Variables read:
433     # - JOB_NAME - String affecting test selection, default if not argument.
434     # Variables set:
435     # - TEST_CODE - The test selection string from environment or argument.
436     # - NODENESS - Node multiplicity of desired testbed.
437     # - FLAVOR - Node flavor string, usually describing the processor.
438
439     set -exuo pipefail
440
441     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
442     if [[ -z "${TEST_CODE}" ]]; then
443         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
444     fi
445
446     case "${TEST_CODE}" in
447         *"1n-vbox"*)
448             NODENESS="1n"
449             FLAVOR="vbox"
450             ;;
451         *"1n-skx"*)
452             NODENESS="1n"
453             FLAVOR="skx"
454             ;;
455        *"1n-tx2"*)
456             NODENESS="1n"
457             FLAVOR="tx2"
458             ;;
459         *"2n-skx"*)
460             NODENESS="2n"
461             FLAVOR="skx"
462             ;;
463         *"2n-zn2"*)
464             NODENESS="2n"
465             FLAVOR="zn2"
466             ;;
467         *"3n-skx"*)
468             NODENESS="3n"
469             FLAVOR="skx"
470             ;;
471         *"2n-clx"*)
472             NODENESS="2n"
473             FLAVOR="clx"
474             ;;
475         *"2n-dnv"*)
476             NODENESS="2n"
477             FLAVOR="dnv"
478             ;;
479         *"3n-dnv"*)
480             NODENESS="3n"
481             FLAVOR="dnv"
482             ;;
483         *"3n-tsh"*)
484             NODENESS="3n"
485             FLAVOR="tsh"
486             ;;
487         *)
488             # Fallback to 3-node Haswell by default (backward compatibility)
489             NODENESS="3n"
490             FLAVOR="hsw"
491             ;;
492     esac
493 }
494
495
496 function get_test_tag_string () {
497
498     # Variables read:
499     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
500     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
501     # - TEST_CODE - The test selection string from environment or argument.
502     # Variables set:
503     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
504     #   May be empty, or even not set on event types not adding comment.
505
506     # TODO: ci-management scripts no longer need to perform this.
507
508     set -exuo pipefail
509
510     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
511         case "${TEST_CODE}" in
512             *"device"*)
513                 trigger="devicetest"
514                 ;;
515             *"perf"*)
516                 trigger="perftest"
517                 ;;
518             *)
519                 die "Unknown specification: ${TEST_CODE}"
520         esac
521         # Ignore lines not containing the trigger word.
522         comment=$(fgrep "${trigger}" <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
523         # The vpp-csit triggers trail stuff we are not interested in.
524         # Removing them and trigger word: https://unix.stackexchange.com/a/13472
525         # (except relying on \s whitespace, \S non-whitespace and . both).
526         # The last string is concatenated, only the middle part is expanded.
527         cmd=("grep" "-oP" '\S*'"${trigger}"'\S*\s\K.+$') || die "Unset trigger?"
528         # On parsing error, TEST_TAG_STRING probably stays empty.
529         TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
530         if [[ -z "${TEST_TAG_STRING-}" ]]; then
531             # Probably we got a base64 encoded comment.
532             comment=$(base64 --decode <<< "${GERRIT_EVENT_COMMENT_TEXT}" || true)
533             comment=$(fgrep "${trigger}" <<< "${comment}" || true)
534             TEST_TAG_STRING=$("${cmd[@]}" <<< "${comment}" || true)
535         fi
536         if [[ -n "${TEST_TAG_STRING-}" ]]; then
537             test_tag_array=(${TEST_TAG_STRING})
538             if [[ "${test_tag_array[0]}" == "icl" ]]; then
539                 export GRAPH_NODE_VARIANT="icl"
540                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
541             elif [[ "${test_tag_array[0]}" == "skx" ]]; then
542                 export GRAPH_NODE_VARIANT="skx"
543                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
544             elif [[ "${test_tag_array[0]}" == "hsw" ]]; then
545                 export GRAPH_NODE_VARIANT="hsw"
546                 TEST_TAG_STRING="${test_tag_array[@]:1}" || true
547             fi
548         fi
549     fi
550 }
551
552
553 function installed () {
554
555     # Check if the given utility is installed. Fail if not installed.
556     #
557     # Duplicate of common.sh function, as this file is also used standalone.
558     #
559     # Arguments:
560     # - ${1} - Utility to check.
561     # Returns:
562     # - 0 - If command is installed.
563     # - 1 - If command is not installed.
564
565     set -exuo pipefail
566
567     command -v "${1}"
568 }
569
570
571 function reserve_and_cleanup_testbed () {
572
573     # Reserve physical testbed, perform cleanup, register trap to unreserve.
574     # When cleanup fails, remove from topologies and keep retrying
575     # until all topologies are removed.
576     #
577     # Variables read:
578     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
579     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
580     # - BUILD_TAG - Any string suitable as filename, identifying
581     #   test run executing this function. May be unset.
582     # Variables set:
583     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
584     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
585     # Functions called:
586     # - die - Print to stderr and exit.
587     # - ansible_playbook - Perform an action using ansible, see ansible.sh
588     # Traps registered:
589     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
590
591     set -exuo pipefail
592
593     while true; do
594         for topo in "${TOPOLOGIES[@]}"; do
595             set +e
596             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
597             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
598             python3 "${scrpt}" "${opts[@]}"
599             result="$?"
600             set -e
601             if [[ "${result}" == "0" ]]; then
602                 # Trap unreservation before cleanup check,
603                 # so multiple jobs showing failed cleanup improve chances
604                 # of humans to notice and fix.
605                 WORKING_TOPOLOGY="${topo}"
606                 echo "Reserved: ${WORKING_TOPOLOGY}"
607                 trap "untrap_and_unreserve_testbed" EXIT || {
608                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
609                     untrap_and_unreserve_testbed "${message}" || {
610                         die "Teardown should have died, not failed."
611                     }
612                     die "Trap attempt failed, unreserve succeeded. Aborting."
613                 }
614                 # Cleanup + calibration checks.
615                 set +e
616                 ansible_playbook "cleanup, calibration"
617                 result="$?"
618                 set -e
619                 if [[ "${result}" == "0" ]]; then
620                     break
621                 fi
622                 warn "Testbed cleanup failed: ${topo}"
623                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
624             fi
625             # Else testbed is accessible but currently reserved, moving on.
626         done
627
628         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
629             # Exit the infinite while loop if we made a reservation.
630             warn "Reservation and cleanup successful."
631             break
632         fi
633
634         if [[ "${#TOPOLOGIES[@]}" == "0" ]]; then
635             die "Run out of operational testbeds!"
636         fi
637
638         # Wait ~3minutes before next try.
639         sleep_time="$[ ( ${RANDOM} % 20 ) + 180 ]s" || {
640             die "Sleep time calculation failed."
641         }
642         echo "Sleeping ${sleep_time}"
643         sleep "${sleep_time}" || die "Sleep failed."
644     done
645 }
646
647
648 function run_pybot () {
649
650     # Run pybot with options based on input variables. Create output_info.xml
651     #
652     # Variables read:
653     # - CSIT_DIR - Path to existing root of local CSIT git repository.
654     # - ARCHIVE_DIR - Path to store robot result files in.
655     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
656     # - GENERATED_DIR - Tests are assumed to be generated under there.
657     # Variables set:
658     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
659     # Functions called:
660     # - die - Print to stderr and exit.
661
662     set -exuo pipefail
663
664     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
665     all_options+=("--noncritical" "EXPECTED_FAILING")
666     all_options+=("${EXPANDED_TAGS[@]}")
667
668     pushd "${CSIT_DIR}" || die "Change directory operation failed."
669     set +e
670     robot "${all_options[@]}" "${GENERATED_DIR}/tests/"
671     PYBOT_EXIT_STATUS="$?"
672     set -e
673
674     # Generate INFO level output_info.xml for post-processing.
675     all_options=("--loglevel" "INFO")
676     all_options+=("--log" "none")
677     all_options+=("--report" "none")
678     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
679     all_options+=("${ARCHIVE_DIR}/output.xml")
680     rebot "${all_options[@]}" || true
681     popd || die "Change directory operation failed."
682 }
683
684
685 function select_arch_os () {
686
687     # Set variables affected by local CPU architecture and operating system.
688     #
689     # Variables set:
690     # - VPP_VER_FILE - Name of file in CSIT dir containing vpp stable version.
691     # - IMAGE_VER_FILE - Name of file in CSIT dir containing the image name.
692     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
693
694     set -exuo pipefail
695
696     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
697         die "Get OS release failed."
698     }
699
700     case "${os_id}" in
701         "ubuntu"*)
702             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
703             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
704             PKG_SUFFIX="deb"
705             ;;
706         "centos"*)
707             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
708             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
709             PKG_SUFFIX="rpm"
710             ;;
711         *)
712             die "Unable to identify distro or os from ${os_id}"
713             ;;
714     esac
715
716     arch=$(uname -m) || {
717         die "Get CPU architecture failed."
718     }
719
720     case "${arch}" in
721         "aarch64")
722             IMAGE_VER_FILE="${IMAGE_VER_FILE}_ARM"
723             ;;
724         *)
725             ;;
726     esac
727 }
728
729
730 function select_tags () {
731
732     # Variables read:
733     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
734     # - TEST_CODE - String affecting test selection, usually jenkins job name.
735     # - DUT - CSIT test/ subdirectory, set while processing tags.
736     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
737     #   Can be unset.
738     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
739     # - BASH_FUNCTION_DIR - Directory with input files to process.
740     # Variables set:
741     # - TAGS - Array of processed tag boolean expressions.
742
743     set -exuo pipefail
744
745     # NIC SELECTION
746     start_pattern='^  TG:'
747     end_pattern='^ \? \?[A-Za-z0-9]\+:'
748     # Remove the TG section from topology file
749     sed_command="/${start_pattern}/,/${end_pattern}/d"
750     # All topologies DUT NICs
751     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
752                 | grep -hoP "model: \K.*" | sort -u)
753     # Selected topology DUT NICs
754     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
755                | grep -hoP "model: \K.*" | sort -u)
756     # All topologies DUT NICs - Selected topology DUT NICs
757     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
758         die "Computation of excluded NICs failed."
759     }
760
761     # Select default NIC tag.
762     case "${TEST_CODE}" in
763         *"3n-dnv"* | *"2n-dnv"*)
764             default_nic="nic_intel-x553"
765             ;;
766         *"3n-tsh"*)
767             default_nic="nic_intel-x520-da2"
768             ;;
769         *"3n-skx"* | *"2n-skx"* | *"2n-clx"* | *"2n-zn2"*)
770             default_nic="nic_intel-xxv710"
771             ;;
772         *"3n-hsw"* | *"mrr-daily-master")
773             default_nic="nic_intel-xl710"
774             ;;
775         *)
776             default_nic="nic_intel-x710"
777             ;;
778     esac
779
780     sed_nic_sub_cmd="sed s/\${default_nic}/${default_nic}/"
781     sed_nics_sub_cmd="sed -e s/ANDxxv710/ANDnic_intel-xxv710/"
782     sed_nics_sub_cmd+=" | sed -e s/ANDx710/ANDnic_intel-x710/"
783     sed_nics_sub_cmd+=" | sed -e s/ANDxl710/ANDnic_intel-xl710/"
784     sed_nics_sub_cmd+=" | sed -e s/ANDx520-da2/ANDnic_intel-x520-da2/"
785     sed_nics_sub_cmd+=" | sed -e s/ANDx553/ANDnic_intel-x553/"
786     sed_nics_sub_cmd+=" | sed -e s/ANDcx556a/ANDnic_mellanox-cx556a/"
787     sed_nics_sub_cmd+=" | sed -e s/ANDvic1227/ANDnic_cisco-vic-1227/"
788     sed_nics_sub_cmd+=" | sed -e s/ANDvic1385/ANDnic_cisco-vic-1385/"
789     # Tag file directory shorthand.
790     tfd="${JOB_SPECS_DIR}"
791     case "${TEST_CODE}" in
792         # Select specific performance tests based on jenkins job type variable.
793         *"ndrpdr-weekly"* )
794             readarray -t test_tag_array <<< $(sed 's/ //g' \
795                 ${tfd}/mlr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
796                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
797             ;;
798         *"mrr-daily"* )
799             readarray -t test_tag_array <<< $(sed 's/ //g' \
800                 ${tfd}/mrr_daily/${DUT}-${NODENESS}-${FLAVOR}.md |
801                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
802             ;;
803         *"mrr-weekly"* )
804             readarray -t test_tag_array <<< $(sed 's/ //g' \
805                 ${tfd}/mrr_weekly/${DUT}-${NODENESS}-${FLAVOR}.md |
806                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
807             ;;
808         *"report-iterative"* )
809             test_sets=(${TEST_TAG_STRING//:/ })
810             # Run only one test set per run
811             report_file=${test_sets[0]}.md
812             readarray -t test_tag_array <<< $(sed 's/ //g' \
813                 ${tfd}/report_iterative/${NODENESS}-${FLAVOR}/${report_file} |
814                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
815             ;;
816         *"report-coverage"* )
817             test_sets=(${TEST_TAG_STRING//:/ })
818             # Run only one test set per run
819             report_file=${test_sets[0]}.md
820             readarray -t test_tag_array <<< $(sed 's/ //g' \
821                 ${tfd}/report_coverage/${NODENESS}-${FLAVOR}/${report_file} |
822                 eval ${sed_nics_sub_cmd} || echo "perftest") || die
823             ;;
824         * )
825             if [[ -z "${TEST_TAG_STRING-}" ]]; then
826                 # If nothing is specified, we will run pre-selected tests by
827                 # following tags.
828                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
829                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
830                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
831                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
832                                 "!dot1q" "!drv_avf")
833             else
834                 # If trigger contains tags, split them into array.
835                 test_tag_array=(${TEST_TAG_STRING//:/ })
836             fi
837             ;;
838     esac
839
840     # Blacklisting certain tags per topology.
841     #
842     # Reasons for blacklisting:
843     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
844     # TODO: Add missing reasons here (if general) or where used (if specific).
845     case "${TEST_CODE}" in
846         *"2n-skx"*)
847             test_tag_array+=("!ipsec")
848             ;;
849         *"3n-skx"*)
850             test_tag_array+=("!ipsechw")
851             # Not enough nic_intel-xxv710 to support double link tests.
852             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
853             ;;
854         *"2n-clx"*)
855             test_tag_array+=("!ipsec")
856             ;;
857         *"2n-zn2"*)
858             test_tag_array+=("!ipsec")
859             ;;
860         *"2n-dnv"*)
861             test_tag_array+=("!ipsechw")
862             test_tag_array+=("!memif")
863             test_tag_array+=("!srv6_proxy")
864             test_tag_array+=("!vhost")
865             test_tag_array+=("!vts")
866             test_tag_array+=("!drv_avf")
867             ;;
868         *"3n-dnv"*)
869             test_tag_array+=("!memif")
870             test_tag_array+=("!srv6_proxy")
871             test_tag_array+=("!vhost")
872             test_tag_array+=("!vts")
873             test_tag_array+=("!drv_avf")
874             ;;
875         *"3n-tsh"*)
876             # 3n-tsh only has x520 NICs which don't work with AVF
877             test_tag_array+=("!drv_avf")
878             test_tag_array+=("!ipsechw")
879             ;;
880         *"3n-hsw"*)
881             test_tag_array+=("!drv_avf")
882             # All cards have access to QAT. But only one card (xl710)
883             # resides in same NUMA as QAT. Other cards must go over QPI
884             # which we do not want to even run.
885             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
886             ;;
887         *)
888             # Default to 3n-hsw due to compatibility.
889             test_tag_array+=("!drv_avf")
890             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
891             ;;
892     esac
893
894     # We will add excluded NICs.
895     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
896
897     TAGS=()
898
899     # We will prefix with perftest to prevent running other tests
900     # (e.g. Functional).
901     prefix="perftestAND"
902     set +x
903     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
904         # Automatic prefixing for VPP jobs to limit the NIC used and
905         # traffic evaluation to MRR.
906         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
907             prefix="${prefix}mrrAND"
908         else
909             prefix="${prefix}mrrAND${default_nic}AND"
910         fi
911     fi
912     for tag in "${test_tag_array[@]}"; do
913         if [[ "${tag}" == "!"* ]]; then
914             # Exclude tags are not prefixed.
915             TAGS+=("${tag}")
916         elif [[ "${tag}" == " "* || "${tag}" == *"perftest"* ]]; then
917             # Badly formed tag expressions can trigger way too much tests.
918             set -x
919             warn "The following tag expression hints at bad trigger: ${tag}"
920             warn "Possible cause: Multiple triggers in a single comment."
921             die "Aborting to avoid triggering too many tests."
922         elif [[ "${tag}" == *"OR"* ]]; then
923             # If OR had higher precedence than AND, it would be useful here.
924             # Some people think it does, thus triggering way too much tests.
925             set -x
926             warn "The following tag expression hints at bad trigger: ${tag}"
927             warn "Operator OR has lower precedence than AND. Use space instead."
928             die "Aborting to avoid triggering too many tests."
929         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
930             # Empty and comment lines are skipped.
931             # Other lines are normal tags, they are to be prefixed.
932             TAGS+=("${prefix}${tag}")
933         fi
934     done
935     set -x
936 }
937
938
939 function select_topology () {
940
941     # Variables read:
942     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
943     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
944     # - CSIT_DIR - Path to existing root of local CSIT git repository.
945     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
946     # Variables set:
947     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
948     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
949     # Functions called:
950     # - die - Print to stderr and exit.
951
952     set -exuo pipefail
953
954     case_text="${NODENESS}_${FLAVOR}"
955     case "${case_text}" in
956         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
957         # TODO: Double link availability depends on NIC used.
958         "1n_vbox")
959             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
960             TOPOLOGIES_TAGS="2_node_single_link_topo"
961             ;;
962         "1n_skx" | "1n_tx2")
963             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
964             TOPOLOGIES_TAGS="2_node_single_link_topo"
965             ;;
966         "2n_skx")
967             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
968             TOPOLOGIES_TAGS="2_node_*_link_topo"
969             ;;
970         "2n_zn2")
971             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_zn2*.yaml )
972             TOPOLOGIES_TAGS="2_node_*_link_topo"
973             ;;
974         "3n_skx")
975             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
976             TOPOLOGIES_TAGS="3_node_*_link_topo"
977             ;;
978         "2n_clx")
979             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_clx*.yaml )
980             TOPOLOGIES_TAGS="2_node_*_link_topo"
981             ;;
982         "2n_dnv")
983             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
984             TOPOLOGIES_TAGS="2_node_single_link_topo"
985             ;;
986         "3n_dnv")
987             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
988             TOPOLOGIES_TAGS="3_node_single_link_topo"
989             ;;
990         "3n_hsw")
991             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
992             TOPOLOGIES_TAGS="3_node_single_link_topo"
993             ;;
994         "3n_tsh")
995             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
996             TOPOLOGIES_TAGS="3_node_single_link_topo"
997             ;;
998         *)
999             # No falling back to 3n_hsw default, that should have been done
1000             # by the function which has set NODENESS and FLAVOR.
1001             die "Unknown specification: ${case_text}"
1002     esac
1003
1004     if [[ -z "${TOPOLOGIES-}" ]]; then
1005         die "No applicable topology found!"
1006     fi
1007 }
1008
1009
1010 function select_vpp_device_tags () {
1011
1012     # Variables read:
1013     # - TEST_CODE - String affecting test selection, usually jenkins job name.
1014     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
1015     #   Can be unset.
1016     # Variables set:
1017     # - TAGS - Array of processed tag boolean expressions.
1018
1019     set -exuo pipefail
1020
1021     case "${TEST_CODE}" in
1022         # Select specific device tests based on jenkins job type variable.
1023         * )
1024             if [[ -z "${TEST_TAG_STRING-}" ]]; then
1025                 # If nothing is specified, we will run pre-selected tests by
1026                 # following tags. Items of array will be concatenated by OR
1027                 # in Robot Framework.
1028                 test_tag_array=()
1029             else
1030                 # If trigger contains tags, split them into array.
1031                 test_tag_array=(${TEST_TAG_STRING//:/ })
1032             fi
1033             ;;
1034     esac
1035
1036     # Blacklisting certain tags per topology.
1037     #
1038     # Reasons for blacklisting:
1039     # - avf - AVF is not possible to run on enic driver of VirtualBox.
1040     # - vhost - VirtualBox does not support nesting virtualization on Intel CPU.
1041     case "${TEST_CODE}" in
1042         *"1n-vbox"*)
1043             test_tag_array+=("!avf")
1044             test_tag_array+=("!vhost")
1045             ;;
1046         *)
1047             ;;
1048     esac
1049
1050     TAGS=()
1051
1052     # We will prefix with devicetest to prevent running other tests
1053     # (e.g. Functional).
1054     prefix="devicetestAND"
1055     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
1056         # Automatic prefixing for VPP jobs to limit testing.
1057         prefix="${prefix}"
1058     fi
1059     for tag in "${test_tag_array[@]}"; do
1060         if [[ ${tag} == "!"* ]]; then
1061             # Exclude tags are not prefixed.
1062             TAGS+=("${tag}")
1063         else
1064             TAGS+=("${prefix}${tag}")
1065         fi
1066     done
1067 }
1068
1069 function untrap_and_unreserve_testbed () {
1070
1071     # Use this as a trap function to ensure testbed does not remain reserved.
1072     # Perhaps call directly before script exit, to free testbed for other jobs.
1073     # This function is smart enough to avoid multiple unreservations (so safe).
1074     # Topo cleanup is executed (call it best practice), ignoring failures.
1075     #
1076     # Hardcoded values:
1077     # - default message to die with if testbed might remain reserved.
1078     # Arguments:
1079     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
1080     # Variables read (by inner function):
1081     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
1082     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
1083     # Variables written:
1084     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
1085     # Trap unregistered:
1086     # - EXIT - Failure to untrap is reported, but ignored otherwise.
1087     # Functions called:
1088     # - die - Print to stderr and exit.
1089     # - ansible_playbook - Perform an action using ansible, see ansible.sh
1090
1091     set -xo pipefail
1092     set +eu  # We do not want to exit early in a "teardown" function.
1093     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
1094     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
1095     if [[ -z "${wt-}" ]]; then
1096         set -eu
1097         warn "Testbed looks unreserved already. Trap removal failed before?"
1098     else
1099         ansible_playbook "cleanup" || true
1100         python3 "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
1101             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
1102         }
1103         WORKING_TOPOLOGY=""
1104         set -eu
1105     fi
1106 }
1107
1108
1109 function warn () {
1110
1111     # Print the message to standard error.
1112     #
1113     # Arguments:
1114     # - ${@} - The text of the message.
1115
1116     set -exuo pipefail
1117
1118     echo "$@" >&2
1119 }